#pragma once

#include <chrono>

namespace jlog {
    class Timestamp {
    public:
        Timestamp();
    public:
        std::chrono::year Year() {return y;};
        std::chrono::month Month() {return m;};
        std::chrono::day Day() {return d;}
        std::chrono::duration<long, std::ratio<3600>> Hour() {return h;};
        std::chrono::duration<long, std::ratio<60>> Minute() {return M;};
        std::chrono::duration<long> Second() {return s;};
        std::chrono::duration<long, std::ratio<1, 1000>> Millisecond() {return ms;};
    private:
        std::chrono::year y;
        std::chrono::month m;
        std::chrono::day d;
        std::chrono::duration<long, std::ratio<3600>> h;
        std::chrono::duration<long, std::ratio<60>> M;
        std::chrono::duration<long> s;
        std::chrono::duration<long, std::ratio<1, 1000>> ms;
    };
}