#include "jlog/Timestamp.hpp"

namespace jlog {
    Timestamp::Timestamp() {
        auto const timestamp = std::chrono::current_zone()->to_local(std::chrono::system_clock::now());
        auto dp = floor<std::chrono::days>(timestamp);
        std::chrono::year_month_day ymd{floor<std::chrono::days>(timestamp)};
        std::chrono::hh_mm_ss time{floor<std::chrono::milliseconds>(timestamp - dp)};
        y = ymd.year();
        m = ymd.month();
        d = ymd.day();
        h = time.hours();
        M = time.minutes();
        s = time.seconds();
        ms = time.subseconds();
    }
}
