#include "jlog/Token.hpp"

namespace jlog {
    std::string token::Stringer(bool includeColor) {
        std::string msg;
        if (!includeColor)
            return StringerWithoutColor();
        return StringerWithColor();
    }

    std::string token::StringerWithColor() {
        std::string msg;
        if (!delimiter.empty()) {
            return std::format("{}{}{}{}{} ",
                               mcolor::toEscapeCode(colorCode),
                               delimiter[0], content,
                               delimiter[1],
                               mcolor::toEscapeCode(AnsiColor::RESET));
        }
        return std::format("{}{}{} ",
                           mcolor::toEscapeCode(colorCode),
                           content,
                           mcolor::toEscapeCode(AnsiColor::RESET));
    }
    std::string token::StringerWithoutColor() {
        if (!delimiter.empty())
            return std::format("{}{}{} ", delimiter[0], content, delimiter[1]);

        return content + " ";
    }

    std::ostream& operator<<(std::ostream& os, token t) {
        os << t.Stringer();
        return os;
    }
}
